##########################################################################################################################

# Clear workspace
rm(list = ls())


library(readxl)
data <- read_excel("D:/session_averages_for_test_2019_08_07.xls")

# Real GDP

wilcox.test(data$realgdp_ses_mean_low, data$realgdp_ses_mean_baseline, paired = FALSE, alternative = "greater", exact = TRUE)

wilcox.test(data$realgdp_ses_mean_low, data$realgdp_ses_mean_menu, paired = FALSE, alternative = "greater", exact = TRUE)

wilcox.test(data$realgdp_ses_mean_low, data$realgdp_ses_mean_human, paired = FALSE, alternative = "greater", exact = TRUE)

wilcox.test(data$realgdp_ses_mean_baseline, data$realgdp_ses_mean_menu, paired = FALSE, alternative = "greater", exact = TRUE)

wilcox.test(data$realgdp_ses_mean_human, data$realgdp_ses_mean_menu, paired = FALSE, alternative = "greater", exact = TRUE)

wilcox.test(data$realgdp_ses_mean_baseline, data$realgdp_ses_mean_human, paired = FALSE, alternative = "two.sided", exact = TRUE)



# Welfare

wilcox.test(data$welfare_ses_mean_low, data$welfare_ses_mean_baseline, paired = FALSE, alternative = "two.sided", exact = TRUE)

wilcox.test(data$welfare_ses_mean_low, data$welfare_ses_mean_menu, paired = FALSE, alternative = "two.sided", exact = TRUE)

wilcox.test(data$welfare_ses_mean_low, data$welfare_ses_mean_human, paired = FALSE, alternative = "two.sided", exact = TRUE)

wilcox.test(data$welfare_ses_mean_baseline, data$welfare_ses_mean_menu, paired = FALSE, alternative = "two.sided", exact = TRUE)

wilcox.test(data$welfare_ses_mean_human, data$welfare_ses_mean_menu, paired = FALSE, alternative = "two.sided", exact = TRUE)

wilcox.test(data$welfare_ses_mean_baseline, data$welfare_ses_mean_human, paired = FALSE, alternative = "two.sided", exact = TRUE)



# Inflation

wilcox.test(data$inflation_ses_mean_low, data$inflation_ses_mean_baseline, paired = FALSE, alternative = "two.sided", exact = TRUE)

wilcox.test(data$inflation_ses_mean_low, data$inflation_ses_mean_menu, paired = FALSE, alternative = "two.sided", exact = TRUE)

wilcox.test(data$inflation_ses_mean_low, data$inflation_ses_mean_human, paired = FALSE, alternative = "two.sided", exact = TRUE)

wilcox.test(data$inflation_ses_mean_baseline, data$inflation_ses_mean_menu, paired = FALSE, alternative = "two.sided", exact = TRUE)

wilcox.test(data$inflation_ses_mean_human, data$inflation_ses_mean_menu, paired = FALSE, alternative = "two.sided", exact = TRUE)

wilcox.test(data$inflation_ses_mean_baseline, data$inflation_ses_mean_human, paired = FALSE, alternative = "two.sided", exact = TRUE)


# Simulated v. Experimental values

# Baseline
wilcox.test(data$realgdp_ses_mean_baseline, data$sim_gdp_base_baseline, paired = FALSE, alternative = "two.sided", exact = FALSE)

wilcox.test(data$welfare_ses_mean_baseline, data$sim_welfare_base_baseline, paired = FALSE, alternative = "two.sided", exact = FALSE)

wilcox.test(data$inflation_ses_mean_baseline, data$sim_inflation_base_baseline, paired = FALSE, alternative = "two.sided", exact = FALSE)

# Menu Cost
wilcox.test(data$realgdp_ses_mean_menu, data$sim_gdp_menu_baseline, paired = FALSE, alternative = "two.sided", exact = FALSE)

wilcox.test(data$welfare_ses_mean_menu, data$sim_welfare_menu_baseline, paired = FALSE, alternative = "two.sided", exact = FALSE)

wilcox.test(data$inflation_ses_mean_menu, data$sim_inflation_menu_baseline, paired = FALSE, alternative = "two.sided", exact = FALSE)

# Low Friction
wilcox.test(data$realgdp_ses_mean_low, data$sim_gdp_no_fric_baseline, paired = FALSE, alternative = "two.sided", exact = FALSE)

wilcox.test(data$welfare_ses_mean_low, data$sim_welfare_no_fric_baseline, paired = FALSE, alternative = "two.sided", exact = FALSE)

wilcox.test(data$inflation_ses_mean_low, data$sim_inflation_no_fric_baseline, paired = FALSE, alternative = "two.sided", exact = FALSE)

# Human CB
wilcox.test(data$realgdp_ses_mean_human, data$sim_gdp_base_baseline, paired = FALSE, alternative = "two.sided", exact = FALSE)

wilcox.test(data$welfare_ses_mean_human, data$sim_welfare_base_baseline, paired = FALSE, alternative = "two.sided", exact = FALSE)

wilcox.test(data$inflation_ses_mean_human, data$sim_inflation_base_baseline, paired = FALSE, alternative = "two.sided", exact = FALSE)


# Levene Test was performed in Eviews.
