****************Table 2*********************************************************
use "Y:\exp\USdata.dta", clear


*eststo: pwcorr gap  lwages lprices infl ffr  gdpc1_bp if period>=29 & period<=192
*esttab . using corr_coef_matrix.tex, not unstack compress noobs tex replace
eststo clear

foreach vv in lwages lprices infl tot tot_bp {
gen rl`vv'=l1.`vv'
}
foreach var in  gap  gdpc1_bp{
/*
gen l3`var'=l3.`var'
gen l2`var'=l2.`var'
gen l1`var'=l1.`var'
gen f1`var'=f1.`var'
gen f2`var'=f2.`var'
gen f3`var'=f3.`var'
*/


foreach vv in lwages lprices infl tot tot_bp {
estpost corr l3`var' l2`var' l1`var' `var' f1`var' f2`var' f3`var' `vv' if period>=29 & period<=192, matrix
esttab . using corr_coef_`var'.tex, not unstack compress noobs tex append b(a2)
eststo clear
estpost corr `vv' rl`vv' if period>=29 & period<=192, matrix
esttab . using corr_coef_`var'.tex, not unstack compress noobs tex append b(a2)
}
estpost corr `var' lwages lprices infl tot tot_bp ffr if period>=29 & period<=192, matrix
esttab . using corr_coef_`var'.tex, not unstack compress noobs tex append b(a2)
}



*eststo: pwcorr gap  lwages lprices infl ffr  gdpc1_bp if period>=29 & period<=192
*esttab . using corr_coef_matrix.tex, not unstack compress noobs tex replace
eststo clear
foreach var in  gap  gdpc1_bp{
/*
gen l3`var'=l3.`var'
gen l2`var'=l2.`var'
gen l1`var'=l1.`var'
gen f1`var'=f1.`var'
gen f2`var'=f2.`var'
gen f3`var'=f3.`var'
*/
foreach vv in lwages lprices infl tot tot_bp {
estpost corr l3`var' l2`var' l1`var' `var' f1`var' f2`var' f3`var' `vv' if period>=137 & period<=236, matrix
esttab . using corr_coef2_`var'.tex, not unstack compress noobs tex append b(a2)
eststo clear
estpost corr `vv' rl`vv' if period>=137 & period<=236, matrix
esttab . using corr_coef2_`var'.tex, not unstack compress noobs tex append b(a2)
eststo clear
}
estpost corr `var' lwages lprices infl tot tot_bp ffr if period>=137 & period<=236, matrix
esttab . using corr_coef2_`var'.tex, not unstack compress noobs tex append b(a2)
eststo clear
}
****************************Table 3*********************************************
use "Y:\exp\Low_friction.dta", clear
tsset Period


gen lrealgdp=log(rgdp)
gen lempl=log(empl)
gen lprice=log(price)
gen lwage=log(rwage)
gen lsavings=log(savings)
gen lutil=log(util)

eststo clear
foreach var in  gap  {

gen l3`var'=l3.`var'
gen l2`var'=l2.`var'
gen l1`var'=l1.`var'
gen f1`var'=f1.`var'
gen f2`var'=f2.`var'
gen f3`var'=f3.`var'

foreach vv in  lwage lprice infl lsavings unsold lutil {
estpost corr l3`var' l2`var' l1`var' `var' f1`var' f2`var' f3`var' `vv'  if Period>=3 & Period<=52, matrix
esttab . using corr_sim_`var'_Low.tex, not unstack compress noobs tex append b(a2)
eststo clear
gen rl`vv'=l1.`vv'
estpost corr `vv' rl`vv' if Period>=3 & Period<=52, matrix
esttab . using corr_sim_`var'_Low.tex, not unstack compress noobs tex append b(a2)
eststo clear
}
estpost corr  `var' lwage lprice infl lsavings unsold lutil intr if Period>=3 & Period<=52, matrix
esttab . using corr_sim_`var'_Low.tex, not unstack compress noobs tex append b(a2)
eststo clear
}

use "Y:\exp\Baseline.dta", clear
rename L intr
tsset Period

gen lrealgdp=log(rgdp)
gen lempl=log(empl)
gen lprice=log(price)
gen lwage=log(rwage)
gen lsavings=log(savings)
gen lutil=log(util)

eststo clear
foreach var in  gap  {

gen l3`var'=l3.`var'
gen l2`var'=l2.`var'
gen l1`var'=l1.`var'
gen f1`var'=f1.`var'
gen f2`var'=f2.`var'
gen f3`var'=f3.`var'

foreach vv in  lempl lwage lprice infl lsavings unsold lutil {
estpost corr  l3`var' l2`var' l1`var' `var' f1`var' f2`var' f3`var' `vv' if Period>=3 & Period<=52, matrix
esttab . using corr_sim_`var'_B.tex, not unstack compress noobs tex append b(a2)
eststo clear
gen rl`vv'=l1.`vv'
estpost corr `vv' rl`vv' if Period>=3 & Period<=52, matrix
esttab . using corr_sim_`var'_B.tex, not unstack compress noobs tex append b(a2)
eststo clear
}
estpost corr `var' lempl lwage lprice infl lsavings unsold lutil intr  if Period>=3 & Period<=52, matrix
esttab . using corr_sim_`var'_B.tex, not unstack compress noobs tex append b(a2)
eststo clear
}

use "Y:\exp\menu_cost.dta", clear
rename L intr
tsset Period

gen lrealgdp=log(rgdp)
gen lempl=log(empl)
gen lprice=log(price)
gen lwage=log(rwage)
gen lsavings=log(savings)
gen lutil=log(util)

eststo clear
foreach var in  gap  {

gen l3`var'=l3.`var'
gen l2`var'=l2.`var'
gen l1`var'=l1.`var'
gen f1`var'=f1.`var'
gen f2`var'=f2.`var'
gen f3`var'=f3.`var'

foreach vv in  lempl lwage lprice infl lsavings unsold lutil {
estpost corr l3`var' l2`var' l1`var' `var' f1`var' f2`var' f3`var' `vv' if Period>=3 & Period<=52, matrix
esttab . using corr_sim_`var'_M.tex, not unstack compress noobs tex append b(a2)
eststo clear
gen rl`vv'=l1.`vv'
estpost corr `vv' rl`vv' if Period>=3 & Period<=52, matrix
esttab . using corr_sim_`var'_M.tex, not unstack compress noobs tex append b(a2)
eststo clear
}
estpost corr  `var' lempl lwage lprice infl lsavings unsold lutil intr if Period>=3 & Period<=52, matrix
eststo correlation
esttab . using corr_sim_`var'_M.tex, not unstack compress noobs tex append b(a2)
eststo clear
}
*************************************************************************************
*************************Table 5-6***************************************************
use "Y:\exp\exp_data_1-17_ver5.dta", clear
xtset id period

*gen markup=price+labval/prodfun
*gen markup_price=markup/price
*gen markup_wage=markup/(-labval/stock)
*gen markup_cost=markup/(-labval/prodfun)

gen totsavings=savings[_n]+savings[_n+1]+savings[_n+2] if subid==4
replace totsavings=savings[_n-1]+savings[_n]+savings[_n+1] if subid==5
replace totsavings=savings[_n-2]+savings[_n-1]+savings[_n] if subid==6

replace markup_price=0 if markup_price<=-0.6
gen totmarkup_price=markup_price[_n]+markup_price[_n+1]+markup_price[_n+2] if subid==1
replace totmarkup_price=markup_price[_n-1]+markup_price[_n]+markup_price[_n+1] if subid==2
replace totmarkup_price=markup_price[_n-2]+markup_price[_n-1]+markup_price[_n] if subid==3

egen ttutil=mean(utility) if subject>=4 & subject<=6, by(period treatment)
rename period Period
sort session Period
by session Period: egen totmarkup_pricel=mean(totmarkup_price)

by session Period: egen empll=mean(empl)
xtset id Period
gen lempl=log(empll)
gen lprice=log(avgpriceall)
gen lwage=log(agrwage)
gen lsavings=log(totsavings)
gen lutil=log(ttutil)


save "Y:\exp\exp_data_1-17_ver5a.dta", replace

use "Y:\exp\exp_data_1-17_ver5a.dta", clear
cd "Y:\exp"
xtset id Period
drop if subject~=4
drop if session==1

foreach var in  gap  {

gen l3`var'=l3.`var'
gen l2`var'=l2.`var'
gen l1`var'=l1.`var'
gen f1`var'=f1.`var'
gen f2`var'=f2.`var'
gen f3`var'=f3.`var'

foreach vv in  lempl lwage lprice inflation lsavings totmarkup_pricel lutil {
estpost corr l3`var' l2`var' l1`var' `var' f1`var' f2`var' f3`var' `vv' if Period>=3 & Period<=52 & treatment==1, matrix
esttab . using corr_sim_`var'_t1.tex, not unstack compress noobs tex append b(a2)
eststo clear
gen rl`vv'=l1.`vv'
estpost corr `vv' rl`vv' if Period>=3 & Period<=52 & treatment==1, matrix
esttab . using corr_sim_`var'_t1.tex, not unstack compress noobs tex append b(a2)
eststo clear
}
estpost corr  `var' lempl lwage lprice inflation lsavings totmarkup_pricel lutil interest if Period>=3 & Period<=52 & treatment==1, matrix
eststo correlation
esttab . using corr_sim_`var'_t1.tex, not unstack compress noobs tex append b(a2)
eststo clear
}

foreach var in  gap  {

foreach vv in  lempl lwage lprice inflation lsavings totmarkup_pricel lutil {
estpost corr l3`var' l2`var' l1`var' `var' f1`var' f2`var' f3`var' `vv' if Period>=3 & Period<=52 & treatment==2, matrix
esttab . using corr_sim_`var'_t2.tex, not unstack compress noobs tex append b(a2)
eststo clear
estpost corr `vv' rl`vv' if Period>=3 & Period<=52 & treatment==2, matrix
esttab . using corr_sim_`var'_t2.tex, not unstack compress noobs tex append b(a2)
eststo clear
}
estpost corr  `var' lempl lwage lprice inflation lsavings totmarkup_pricel lutil interest if Period>=3 & Period<=52 & treatment==2, matrix
eststo correlation
esttab . using corr_sim_`var'_t2.tex, not unstack compress noobs tex append b(a2)
eststo clear
}

foreach var in  gap  {

foreach vv in  lempl lwage lprice inflation lsavings totmarkup_pricel lutil {
estpost corr l3`var' l2`var' l1`var' `var' f1`var' f2`var' f3`var' `vv' if Period>=3 & Period<=52 & treatment==3, matrix
esttab . using corr_sim_`var'_t3.tex, not unstack compress noobs tex append b(a2)
eststo clear
estpost corr `vv' rl`vv' if Period>=3 & Period<=52 & treatment==3, matrix
esttab . using corr_sim_`var'_t3.tex, not unstack compress noobs tex append b(a2)
eststo clear
}
estpost corr  `var' lempl lwage lprice inflation lsavings totmarkup_pricel lutil interest if Period>=3 & Period<=52 & treatment==3, matrix
eststo correlation
esttab . using corr_sim_`var'_t3.tex, not unstack compress noobs tex append b(a2)
eststo clear
}

foreach var in  gap  {

foreach vv in  lempl lwage lprice inflation lsavings totmarkup_pricel lutil {
estpost corr l3`var' l2`var' l1`var' `var' f1`var' f2`var' f3`var' `vv' if Period>=3 & Period<=52 & treatment==4, matrix
esttab . using corr_sim_`var'_t4.tex, not unstack compress noobs tex append b(a2)
eststo clear
estpost corr `vv' rl`vv' if Period>=3 & Period<=52 & treatment==4, matrix
esttab . using corr_sim_`var'_t4.tex, not unstack compress noobs tex append b(a2)
eststo clear
}
estpost corr  `var' lempl lwage lprice inflation lsavings totmarkup_pricel lutil interest if Period>=3 & Period<=52 & treatment==4, matrix
eststo correlation
esttab . using corr_sim_`var'_t4.tex, not unstack compress noobs tex append b(a2)
eststo clear
}
*****************************Table A1

foreach var in  inflation  {

gen l3`var'=l3.`var'
gen l2`var'=l2.`var'
gen l1`var'=l1.`var'
gen f1`var'=f1.`var'
gen f2`var'=f2.`var'
gen f3`var'=f3.`var'

foreach vv in  gap {
estpost corr l3`var' l2`var' l1`var' `var' f1`var' f2`var' f3`var' `vv' if Period>=3 & Period<=52 & treatment==1, matrix
esttab . using corr_sim_`var'_a1t1.tex, not unstack compress noobs tex append b(a2)
eststo clear
}
foreach vv in  gap {
estpost corr l3`var' l2`var' l1`var' `var' f1`var' f2`var' f3`var' `vv' if Period>=3 & Period<=52 & treatment==2, matrix
esttab . using corr_sim_`var'_a1t2.tex, not unstack compress noobs tex append b(a2)
eststo clear
}
foreach vv in  gap {
estpost corr l3`var' l2`var' l1`var' `var' f1`var' f2`var' f3`var' `vv' if Period>=3 & Period<=52 & treatment==3, matrix
esttab . using corr_sim_`var'_a1t3.tex, not unstack compress noobs tex append b(a2)
eststo clear
}
foreach vv in  gap {
estpost corr l3`var' l2`var' l1`var' `var' f1`var' f2`var' f3`var' `vv' if Period>=3 & Period<=52 & treatment==4, matrix
esttab . using corr_sim_`var'_a1t4.tex, not unstack compress noobs tex append b(a2)
eststo clear
}


}

