clear all;
clc;

%giving initial budget for them

% Constants
NumPer = 70;                                                             % Number of periods
NumProd = 3;                                                               % Number of producers (work providers) in each Group (economy)
NumCons = 3;                                                               % Number of consumers (workers)
NumBank = 1;                                                               % Size of the Central Bank committee
NumLab = 10;                                                               % Number of labor units each consumer can sell at max

target = 3;                                                                % Inflation target
baseperiod = 1;                                                            % Base period for prices when calculating real variables
lambda = 0.2;                                                              % Banker's loss function sensitivity to output gap
rho = 0.8;                                                                 % Productivity shock's persistence factor
delta = 0.2;                                                               % Productivity iid shock's standard deviation
AAA=0.7;                                                                   % constant in each period for productivity shock eq: prod(t)=AAA+rho*prod(t-1)+delta*epsilon(1,t);
sigma = 0.5;                                                               % Inverse of the intertemporal elasticity of substitution (consumption vs. saving)%%%%%%%
gamma1=1.5;                                                                % gamma1 and gamma2 parameters for Taylor rule (not in efect at the moment)
gamma2=0.5;                                                                %
%eta=2;                                                                    % for disutility of work
hsig=0.2;                                                                 %variance for the preference shocks


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% grid %%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% search %%%%%%%%%%%%%%%%%%%%%%%%%%%
k1=15;
z1=1.2;
k2=length(k1);
z2=length(z1);
k3=zeros;
z3=zeros;

%info=zeros(k2*z2,3);                                                       %this saves the sum of profits for different k2 z2 parameters

%for k3=1:k2
%    for z3=1:z2
%
%         k3
%          z3
i=zeros;
j=zeros;
t=zeros;
% Variables
Interest = zeros(1,NumPer);                                                 %interest rate in each period (1+r) format
int=zeros(1,NumPer);                                                        % r in %
Inflation = zeros(NumPer,1);                                                %inflation in each period
Gap = zeros(NumPer,1);                                                      %GdP gap in each period (not yet implemented)
GDP = zeros(NumPer,1);                                                      %Gdp in each period
realGDP = zeros(NumPer,1);                                                  %real GdP in each period
rGDPg = zeros(NumPer,1);                                                    %real gdp growth
pGDP = zeros(NumPer,1);                                                     %potential gdp

production = zeros(NumProd,NumPer);                                         %production of firm j at period t
prodmsales=zeros(NumProd,NumPer);                                           %the difference between production and sales: products unsold
sales = zeros(NumProd,NumPer);                                              %number of products sold of firm j at time t
price = zeros(NumProd,NumPer);                                              %price of the good j at time t
agrwage = zeros(NumCons,NumPer);                                            %total wage mass for each consumer in each period: wage*actual labor


%consumers
L=10;                                                                       %total time can be used for working

wage=zeros(NumCons,NumPer);                                                 %wage per workunit, consumer j works for firm j exclusively

consume=zeros(NumCons,NumProd,NumPer);                                      % intermediate
cconsume=zeros(NumCons,NumProd,NumPer);                                     %             variables to
ccconsume=zeros(NumCons,NumProd,NumPer);                                    %                         calculate
cccconsume=zeros(NumCons,NumProd,NumPer);                                   %                                  consumption of each good for each consumer
ccccconsume=zeros(NumCons,NumProd,NumPer);                                  %consumer s consumes from producer j at period t, # of goods
m=zeros(3,1);                                                               % variables for some procedure
mm=zeros(3,1);                                                              %
mv=zeros;                                                                   %
mp=zeros;                                                                   %
consumesum=zeros(NumProd,NumPer);                                           %intermediate variables
cconsumesum=zeros(NumProd,NumPer);                                          %                     to calculate
cccconsumesum=zeros(NumProd,NumPer);                                        %                             aggregate demand
ccccconsumesum=zeros(NumProd,NumPer);                                       %aggregate demand for good j per period
spending=zeros(NumCons,NumPer);                                             %measure total spending of a consumer per period
consumev=zeros(NumCons,NumProd,NumPer);                                     % value of consumption of a good for a give consumer

savings=zeros(NumCons,NumPer);                                              %savings for a consumer: comes from money not spent on not-even number of consumption
savinginit=zeros(NumCons,1);                                                % initial savings
savinginit=[1500;1500;1500];



workfirm=zeros(NumProd,NumPer);                                             %how much labor a firm has
workcost=zeros(NumProd,NumPer);                                             %how much the total labor cost for each firm in each period
utils=zeros(NumCons,NumPer);
utils_sum=zeros(NumCons,1);
% Shocks
%preference shock
randn('seed',2);
epsilon_ztree=randn(80,NumProd+1);                                          %shocks in ztree
epsilon_rest=randn(NumPer-80,NumProd+1);                                    %shocks needed to fill in NumPer
epsilon_ztree=epsilon_ztree';
epsilon_rest=epsilon_rest';
epsilon=[epsilon_ztree];
%epsilon=[epsilon_rest epsilon_ztree];                                       %last 80 period shocks is exactly the same as in z-tree
%transposed  4  x 80 long
%first row  = productivity shock
%second row = taste shock for good 1
%third row  = taste shock for good 2
%fourth row = taste shock for good 3


mu=zeros(3,3);                                                              % parameters for
%mu=[58,38,42;42,52,38;38,42,62];                                                  % the preference shocks
tau=ones(3,3)*0.8;
%tau=[0.909769,0.9097087,0.909741;0.90097013,0.9097492,0.90987306;0.909718,0.909751,0.909728];



h=zeros(NumProd,NumCons,NumPer);                                            %preference shocks


hinit=zeros(NumProd,NumCons);                                               % initial vaule for pref shocks
hinit(:,:)=1*[475,310,189;191,465,320;165,298,485];
mu=0.2*hinit(:,:);
Ainit=3;                                                                    % initial vaule for the productivity shock

prod=zeros(1,NumPer);                                                       %production shocks
production=zeros(NumProd,NumPer);                                           %production of firm j at time t
profits=zeros(NumProd,NumPer);                                              %profits of firm j at time t
profitshareinit=0;                                                          %initial profitshares
profits_sum=zeros(NumProd,1);

sumpriceinit=(3*k1-0.8)/3;                                                             %prices in the 0th period


Interestinit=1.03;                                                          %interest rate in initial period
Interest(1,1)=Interestinit;

% aqwa=1;
% zzxxq=0.01:2:40;
% zzxxw=0.01:2:40;
% zzxxe=0.01:2:40;
% for iiij=1:length(zzxxq)
%     for iiiw=1:length(zzxxw)
%         for iiie=1:length(zzxxe)
%             pp(:,aqwa)=[zzxxq(iiij);zzxxw(iiiw);zzxxe(iiie)];
%             aqwa=aqwa+1;
%         end
%     end
% end
%     aqwa=1;
%     zzxxq=0.01:0.5:40;
%     for iiij=1:length(zzxxq)
%         pp(:,aqwa)=[zzxxq(iiij);zzxxq(iiij);zzxxq(iiij)];
%         aqwa=aqwa+1;
%     end
%     lngtww=aqwa-1;

lngtww=1;

for t=1:NumPer
    t
    %Taylor rule for interest rate
    int(1,t)=3;
    if t==1
        Interest(1,t)=1+0.01*int(1,t);
        price(:,1)=[k1;k1-0.6;k1-0.2];                              % setting prices
        prod(t)=AAA+rho*Ainit+delta*epsilon(1,t);                           %calculating productivity shock
    end
    if t>=2
        int(t)=(round((target+gamma1*(IInf(t-1)-target))*10))/10;
        if int(t)<0
            int(t)=0;
        end
        if int(t)>30
            int(t)=30;
        end
        Interest(1,t)=1+0.01*int(1,t);
        prod(t)=AAA+rho*Pprod(t-1)+delta*epsilon(1,t);
        
        aqwa=1;
        zzxxq=-3:0.1:3;
        for iiij=1:length(zzxxq)
        pp(:,aqwa)=[max(Pprice(1,t-1),3.1)+zzxxq(iiij);max(Pprice(2,t-1),3.1)+zzxxq(iiij);max(Pprice(3,t-1),3.1)+zzxxq(iiij)];
        aqwa=aqwa+1;
        end
        lngtww=aqwa-1;
    end

    
    for ttxi=1:lngtww
        for ttforw=0:0%(NumPer-t-1)
            if ttforw>0
                    int(t+ttforw)=(round((target+gamma1*(Inflation(t+ttforw-1)-target))*10))/10;
                    if int(t+ttforw)<0
                    int(t+ttforw)=0;
                    end
                    if int(t+ttforw)>30
                    int(t+ttforw)=30;
                    end
                    Interest(1,t)=1+0.01*int(1,t+ttforw);
                    prod(t+ttforw)=AAA+rho*prod(t+ttforw-1)+delta*epsilon(1,t+ttforw);
            end
            
            
        if (t+ttforw)==1
            price(:,t)=[k1;k1-0.6;k1-0.2];
            wage(:,t)=max(price(:,t))*prod(t+ttforw)/z1;
        elseif t==1
            price(:,t)=[k1;k1-0.6;k1-0.2];
            wage(:,t+ttforw)=max(price(:,t))*prod(t+ttforw)/z1;
        else
            price(:,t)=pp(:,ttxi);
            wage(:,t+ttforw)=max(price(:,t))*prod(t+ttforw)/z1;
            %wage(:,t+ttforw)=max(Pprice(:,t-1))*prod(t+ttforw)/z1;
        end
        %productivity shock
        % zz1=1.01:0.05:1.5;
        % for jjj=1:10
        
        %wage(:,t)=max(price(:,t))*prod(t+ttforw)/z1;
        %wage(:,t)=mean(price(:,t))*prod(t)/zz1(jjj);                                    %calculating wages
        %consumer-firm assigned so one consumer works for only one
        %firm, firm1-consumer1, firm2-consumer2, firm3-consumer3
        % wage=price_1*A_1/markup parameter
        
        for s=1:NumCons,
            for j=1:NumProd,
                if (t+ttforw)==1
                    h(j,s,1)=mu(j,s)+tau(j,s)*hinit(j,s)+hsig*epsilon(j+1,t);
                %preference shocks calculating
                elseif ttforw==0 && t~=1
                    h(j,s,t)=mu(j,s)+tau(j,s)*Hh(j,s,t-1)+hsig*epsilon(j+1,t);
                else
                    h(j,s,t+ttforw)=mu(j,s)+tau(j,s)*h(j,s,t+ttforw-1)+hsig*epsilon(j+1,t+ttforw);
                end
                
                
            end
        end
        
        
        for s=1:NumProd,                                                          %calculating the optimal work of consumers
            
            
            workfirm(s,t+ttforw)=0.338504*(h(1,s,t+ttforw)^2/price(1,t)+h(2,s,t+ttforw)^2/price(2,t)+h(3,s,t+ttforw)^2/price(3,t))^(1/5)*wage(s,t+ttforw)^(1/5); %0.30901699437494745*(h(1,s,t)^2/price(1,t)+h(2,s,t)^2/price(2,t)+h(3,s,t)^2/price(3,t))^(1/5)*wage(s,t)^(1/5);   %how much consumer s works for firm s
            
            workfirm(s,t+ttforw)=round(workfirm(s,t+ttforw));
            
            
        end
        
        
        workcost(:,t)=wage(:,t+ttforw).*workfirm(:,t+ttforw);                                  %how much a firm pays out as wages in each period
        
        agrwage(:,t)=wage(:,t+ttforw).*workfirm(:,t+ttforw);                                   %wage for a consumer in a given period
        
        %production
        
        production(:,t+ttforw)=floor(prod(t+ttforw).*workfirm(:,t+ttforw));                            %production of a firm at time t
        %consumption   savings=0 for the time being
        for s=1:NumCons,
            %calculating the optimal consumption for each consumer and each good
            %in every period
            %with the following budget:
            %B=agrwage(s,t)+savings(s,t-1)*Interest(t)+profitshare(t)
            %workcost calculating is still not done!!!!!
            if (t+ttforw)==1
                consume(s,1,t)=(agrwage(s,t)+savinginit(s)*Interest(1,t)+profitshareinit)/(price(1,t)+(price(1,t)*h(2,s,t)/h(1,s,t))^2/price(2,t)+(price(1,t)*h(3,s,t)/h(1,s,t))^2/price(3,t));
                cconsume(s,1,t)=floor(consume(s,1,t));
                consume(s,2,t)=(price(1,t)*h(2,s,t)/(h(1,s,t)*price(2,t)))^2*(agrwage(s,t)+savinginit(s)*Interest(1,t)+profitshareinit)/(price(1,t)+(price(1,t)*h(2,s,t)/h(1,s,t))^2/price(2,t)+(price(1,t)*h(3,s,t)/h(1,s,t))^2/price(3,t));
                cconsume(s,2,t)=floor(consume(s,2,t));
                consume(s,3,t)=(price(1,t)*h(3,s,t)/(h(1,s,t)*price(3,t)))^2*(agrwage(s,t)+savinginit(s)*Interest(1,t)+profitshareinit)/(price(1,t)+(price(1,t)*h(2,s,t)/h(1,s,t))^2/price(2,t)+(price(1,t)*h(3,s,t)/h(1,s,t))^2/price(3,t));
                cconsume(s,3,t)=floor(consume(s,3,t));    
            elseif ttforw==0 && t~=1
                consume(s,1,t)=(agrwage(s,t)+Ssavings(s,t-1)*Interest(1,t)+Pprofitshare(t-1))/(price(1,t)+(price(1,t)*h(2,s,t)/h(1,s,t))^2/price(2,t)+(price(1,t)*h(3,s,t)/h(1,s,t))^2/price(3,t));
                cconsume(s,1,t)=floor(consume(s,1,t));
                consume(s,2,t)=(price(1,t)*h(2,s,t)/(h(1,s,t)*price(2,t)))^2*(agrwage(s,t)+Ssavings(s,t-1)*Interest(1,t)+Pprofitshare(t-1))/(price(1,t)+(price(1,t)*h(2,s,t)/h(1,s,t))^2/price(2,t)+(price(1,t)*h(3,s,t)/h(1,s,t))^2/price(3,t));
                cconsume(s,2,t)=floor(consume(s,2,t));
                consume(s,3,t)=(price(1,t)*h(3,s,t)/(h(1,s,t)*price(3,t)))^2*(agrwage(s,t)+Ssavings(s,t-1)*Interest(1,t)+Pprofitshare(t-1))/(price(1,t)+(price(1,t)*h(2,s,t)/h(1,s,t))^2/price(2,t)+(price(1,t)*h(3,s,t)/h(1,s,t))^2/price(3,t));
                cconsume(s,3,t)=floor(consume(s,3,t));
            else 
                consume(s,1,t)=(agrwage(s,t)+savings(s,t+ttforw-1)*Interest(1,t)+profitshare(t+ttforw-1))/(price(1,t)+(price(1,t)*h(2,s,t+ttforw)/h(1,s,t+ttforw))^2/price(2,t)+(price(1,t)*h(3,s,t+ttforw)/h(1,s,t+ttforw))^2/price(3,t));
                cconsume(s,1,t)=floor(consume(s,1,t));
                consume(s,2,t)=(price(1,t)*h(2,s,t+ttforw)/(h(1,s,t+ttforw)*price(2,t)))^2*(agrwage(s,t)+savings(s,t+ttforw-1)*Interest(1,t)+profitshare(t+ttforw-1))/(price(1,t)+(price(1,t)*h(2,s,t+ttforw)/h(1,s,t+ttforw))^2/price(2,t)+(price(1,t)*h(3,s,t+ttforw)/h(1,s,t+ttforw))^2/price(3,t));
                cconsume(s,2,t)=floor(consume(s,2,t));
                consume(s,3,t)=(price(1,t)*h(3,s,t+ttforw)/(h(1,s,t+ttforw)*price(3,t)))^2*(agrwage(s,t)+savings(s,t+ttforw-1)*Interest(1,t)+profitshare(t+ttforw-1))/(price(1,t)+(price(1,t)*h(2,s,t+ttforw)/h(1,s,t+ttforw))^2/price(2,t)+(price(1,t)*h(3,s,t+ttforw)/h(1,s,t+ttforw))^2/price(3,t));
                cconsume(s,3,t)=floor(consume(s,3,t));    
            end
        end
        
        
        consumesum(:,t)=consume(1,:,t)+consume(2,:,t)+consume(3,:,t);
        cconsumesum(:,t)=cconsume(1,:,t)+cconsume(2,:,t)+cconsume(3,:,t);
        % the case of more consumption than production
        
        if cconsumesum(1,t)>production(1,t+ttforw)
            ccconsume(1,1,t)=(cconsume(1,1,t)/cconsumesum(1,t))*production(1,t+ttforw);
            
            
            
            
            ccconsume(2,1,t)=(cconsume(2,1,t)/cconsumesum(1,t))*production(1,t+ttforw);
            
            
            
            
            ccconsume(3,1,t)=(cconsume(3,1,t)/cconsumesum(1,t))*production(1,t+ttforw);
            
            
            % allocation of the extra unit remaining from fractions
            m(1)=ccconsume(1,1,t)-floor(ccconsume(1,1,t));
            m(2)=ccconsume(2,1,t)-floor(ccconsume(2,1,t));
            m(3)=ccconsume(3,1,t)-floor(ccconsume(3,1,t));
            
            [mv,mp]=max(m);
            
            for l=1:3;                       %indicator function for the telling who gets the extra unit
                if l==mp
                    mm(l)=1;
                else
                    mm(l)=0;
                end
            end
            
            
            
            cccconsume(1,1,t)=floor(ccconsume(1,1,t))+mm(1);
            cccconsume(2,1,t)=floor(ccconsume(2,1,t))+mm(2);
            cccconsume(3,1,t)=floor(ccconsume(3,1,t))+mm(3);
            
            
        else
            cccconsume(1,1,t)=cconsume(1,1,t);
            cccconsume(2,1,t)=cconsume(2,1,t);
            cccconsume(3,1,t)=cconsume(3,1,t);
        end
        
        
        
        
        
        
        
        
        if cconsumesum(2,t)>production(2,t+ttforw)
            ccconsume(1,2,t)=(cconsume(1,2,t)/cconsumesum(2,t))*production(2,t+ttforw);
            ccconsume(2,2,t)=(cconsume(2,2,t)/cconsumesum(2,t))*production(2,t+ttforw);
            ccconsume(3,2,t)=(cconsume(3,2,t)/cconsumesum(2,t))*production(2,t+ttforw);
            
            
            m(1)=ccconsume(1,2,t)-floor(ccconsume(1,2,t));
            m(2)=ccconsume(2,2,t)-floor(ccconsume(2,2,t));
            m(3)=ccconsume(3,2,t)-floor(ccconsume(3,2,t));
            
            [mv,mp]=max(m);
            
            for l=1:3;                       %indicator function for the telling who gets the extra unit
                if l==mp
                    mm(l)=1;
                else
                    mm(l)=0;
                end
            end
            
            
            
            cccconsume(1,2,t)=floor(ccconsume(1,2,t))+mm(1);
            cccconsume(2,2,t)=floor(ccconsume(2,2,t))+mm(2);
            cccconsume(3,2,t)=floor(ccconsume(3,2,t))+mm(3);
            
            
        else
            cccconsume(1,2,t)=cconsume(1,2,t);
            cccconsume(2,2,t)=cconsume(2,2,t);
            cccconsume(3,2,t)=cconsume(3,2,t);
        end
        
        
        if cconsumesum(3,t)>production(3,t+ttforw)
            ccconsume(1,3,t)=(cconsume(1,3,t)/cconsumesum(3,t))*production(3,t+ttforw);
            ccconsume(2,3,t)=(cconsume(2,3,t)/cconsumesum(3,t))*production(3,t+ttforw);
            ccconsume(3,3,t)=(cconsume(3,3,t)/cconsumesum(3,t))*production(3,t+ttforw);
            
            
            m(1)=ccconsume(1,3,t)-floor(ccconsume(1,3,t));
            m(2)=ccconsume(2,3,t)-floor(ccconsume(2,3,t));
            m(3)=ccconsume(3,3,t)-floor(ccconsume(3,3,t));
            
            [mv,mp]=max(m);
            
            for l=1:3;                       %indicator function for the telling who gets the extra unit
                if l==mp
                    mm(l)=1;
                else
                    mm(l)=0;
                end
            end
            
            
            
            cccconsume(1,3,t)=floor(ccconsume(1,3,t))+mm(1);
            cccconsume(2,3,t)=floor(ccconsume(2,3,t))+mm(2);
            cccconsume(3,3,t)=floor(ccconsume(3,3,t))+mm(3);
            
            
        else
            cccocnsume(1,3,t)=cconsume(1,3,t);
            cccconsume(2,3,t)=cconsume(2,3,t);
            cccconsume(3,3,t)=cconsume(3,3,t);
        end
        
        cccconsumesum(:,t)=cccconsume(1,:,t)+cccconsume(2,:,t)+cccconsume(3,:,t);
        
        ccccconsume(:,:,t)=max(0,cccconsume(:,:,t));                              %consumption of each consumer for good j at time t
        ccccconsumesum(:,t)=ccccconsume(1,:,t)+ccccconsume(2,:,t)+ccccconsume(3,:,t); %aggregate demand for product j at time t
        sales(:,t)=0;
        spending(:,t)=0;
        for s=1:NumCons,
            for j=1:NumProd,
                consumev(s,j,t)=ccccconsume(s,j,t)*price(j,t);                 %calculating how much spend on a good by a consumer
                spending(s,t)=spending(s,t)+consumev(s,j,t);                   %agregating total spendings per consumer
                sales(j,t)=sales(j,t)+ccccconsume(s,j,t);                      %calculating total demand for a given producer
            end
        end
        
        
        %sales(:,t)=min(sales(:,t),production(:,t));                              % sales and production have to be positive for this step!!!!!!!!!!!!!!
        
        prodmsales(:,t+ttforw)=production(:,t+ttforw)-sales(:,t);
        
        for s=1:NumCons
            utils(s,t+ttforw)=(h(1,s,t+ttforw)*((ccccconsume(s,1,t)))^0.5)/0.5+(h(2,s,t+ttforw)*((ccccconsume(s,2,t)))^0.5)/0.5+(h(3,s,t+ttforw)*((ccccconsume(s,3,t)))^0.5)/0.5-15*(workfirm(s,t+ttforw)^3)/3;
        end
        if ttforw==0
        FUtils(:,t)=(0.99^(t+ttforw)).*utils(:,t+ttforw);
        else
        FUtils(:,t)=FUtils(:,t)+((0.99^(t+ttforw)).*utils(:,t+ttforw));
        end
        
        if (t+ttforw)==1
            savings(:,t)=savinginit(:)*Interest(1,t)+agrwage(:,t)-spending(:,t);                                  %calculating the unsold products for each firm
        elseif ttforw==0 && t~=1
            adad(:,1)=Ssavings(:,t-1)*Interest(1,t);
            if adad(:,1)<0
                adad(:,1)=0;
            end
            savings(:,t)=adad(:,1)+agrwage(:,t)-spending(:,t);
        else
            adad(:,1)=savings(:,t+ttforw-1)*Interest(1,t);
            if adad(:,1)<0
                adad(:,1)=0;
            end
            savings(:,t+ttforw)=adad(:,1)+agrwage(:,t)-spending(:,t);
        end
        
        
        if t>1 && price(1,t)~=Pprice(1,t-1)
            menucst(1,t)=0;
        else
            menucst(1,t)=0;
        end
        if t>1 && price(2,t)~=Pprice(2,t-1)
            menucst(2,t)=0;
        else
            menucst(2,t)=0;
        end
        if t>1 && price(3,t)~=Pprice(3,t-1)
            menucst(3,t)=0.0;
        else
            menucst(3,t)=0;
        end
        if t==1
            profits(:,t) = sales(:,t).*price(:,t)-workcost(:,t);
            PROF(:,ttxi,t)=sales(:,t).*price(:,t)-workcost(:,t);
            %MENU(:,ttxi,t)=0;
        else
            profits(:,t) = sales(:,t).*price(:,t)-workcost(:,t)-menucst(:,t);
            PROF(:,ttxi,t)=sales(:,t).*price(:,t)-workcost(:,t)-menucst(:,t);
            %MENU(:,ttxi,t)=menucst(:,t);
        end
        %calculating profits for each firm
        sumprofit(t) = sum(profits(:,t));                                        %total profit in every period
        %meanprofit(t)= mean(profits(:,t));
        profitshare(t+ttforw)=sumprofit(t)/NumCons;%+26;                                   %calculating profit share + government subsidgy
        
        GDP(t)=sum(sales(:,t).*price(:,t));
        realGDP(t+ttforw)=sum(sales(:,t).*price(:,1));
        realGDPp(t+ttforw)=sum(production(1,t+ttforw).*price(:,1));
        sumprice(t)=mean(price(:,t));  
        
        if ttforw==0
        Fprofits(:,t)=profits(:,t)/((sumprice(t)/sumpriceinit));
        else
            %Fprofits(:,t)=Fprofits(:,t)+profits(:,t)/((sumprice(t)/sumpriceinit));
            Fprofits(:,t)=Fprofits(:,t)+((0.99^(ttforw)).*profits(:,t))/((sumprice(t)/sumpriceinit));
        end
        
        % Aggregation of data
        

        
 
        if t==1
            Inflation(1)=(sumprice(1)/sumpriceinit-1)*100;
        else
            Inflation(t+ttforw)=(sumprice(t)/Ssumprice(t-1)-1)*100;
        end
        %rGDPg(t)=realGDP(t)/RrealGDP(t-1); 
        if t>4
            inf4(t)=(sumprice(t)/Ssumprice(t-4)-1)*100;  
        elseif t==1
            inf4(t)=(sumprice(t)/sumpriceinit-1)*100*4;
        else
            inf4(t)=(sumprice(t)/Ssumprice(t-1)-1)*100*4;
        end
       
        end %forward loop
        %UUall(ttxi,t)=(median(Fprofits(:,t),1))/100; 
        %UUall(ttxi,t)=(median(FUtils(:,t),1))/10000;
        UUall(ttxi,t)=(sum(FUtils(:,t),1))/10000+(sum(Fprofits(:,t),1))/100; 
        if ttxi==1 || UUall(ttxi,t)>TUUall(t)
                GGDP(t)=GDP(t);
                IInf(t)=Inflation(t);
                IInf4(t)=inf4(t);
                TUUall(t)=UUall(ttxi,t);
                UUtil(t)=sum(utils(:,t),1);
                IInt(t)=int(t);
                PProfit(t,:)=Fprofits(:,t);
                Pprice(:,t)=price(:,t);
                Ssumprice(t)=sumprice(t);
                Pprofitshare(t)=profitshare(t);
                Ssavings(:,t)=savings(:,t);
                RrealGDP(t)=realGDP(t);
                RrealGDPp(t)=realGDPp(t);
                Wwage(:,t)=wage(:,t);
                Wworkfirm(:,t)=workfirm(:,t);
                Pprodmsales(:,t)=prodmsales(:,t);
                Cccccconsume(:,:,t)=ccccconsume(:,:,t);
                Pproduction(:,t)=production(:,t);
                %Mmeanprofit(t)=meanprofit(t);
                Pprofits(:,t)=profits(:,t);
                TTXI(t)=ttxi;
                Hh(:,:,t)=h(:,:,t);
                Pprod(t)=prod(t);

                
                %Fprofits
                %FUtils
                %                    Mrk(t)=zz1(jjj);

        end
    end
    
end
    utils_sum(:)=sum(utils(:,:),2);
    profits_sum(:)=sum(profits(:,:),2);
UUtil=UUtil'/10000;
IInf=IInf';
IInt=IInt';
 RrealGDP=RrealGDP';   
 RrealGDPp=RrealGDPp'; 
  empl=sum(Wworkfirm,1)'; 
  TSsaving=sum(Ssavings,1)'; 
  TPprodmsales=sum(Pprodmsales,1)';
    %SAVE
gap(:,1)=(RrealGDP-sum((floor(3.5.*Wworkfirm(:,t))).*price(:,1)))/(sum((floor(3.5.*Wworkfirm(:,t))).*price(:,1)));
 gapp(:,1)=(RrealGDPp-sum((floor(3.5.*Wworkfirm(:,t))).*price(:,1)))/(sum((floor(3.5.*Wworkfirm(:,t))).*price(:,1))); 
 pindex=(Ssumprice'./sumpriceinit);
 rWwage=(mean(Wwage,1))'./pindex;  
 printout=[gap,gapp,empl,RrealGDP,rWwage,pindex,IInf,TSsaving,TPprodmsales,UUtil,IInt];  
    
    
    
    
    
    
    
    
    
    
    
    
    
    
